package de.ozgcloud.apilib.vorgang;

import java.util.UUID;

public class OzgCloudVorgangTestFactory {

	public static final OzgCloudVorgangId ID = OzgCloudVorgangId.from(UUID.randomUUID().toString());
	public static final long VERSION = 42L;

	public static final String VORGANG_NAME = "Antrag auf Waffelschein";
	public static final String VORGANG_NUMMER = "123-abc-XY";

	public static OzgCloudVorgang create() {
		return createBuilder().build();
	}

	public static OzgCloudVorgang.OzgCloudVorgangBuilder createBuilder() {
		return OzgCloudVorgang.builder()
				.id(ID)
				.version(VERSION)
				.vorgangName(VORGANG_NAME)
				.vorgangNummer(VORGANG_NUMMER)
				.header(OzgCloudVorgangHeaderTestFactory.create())
				.eingang(OzgCloudVorgangEingangTestFactory.create());

	}
}
