package de.ozgcloud.client.autoconfigure;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;
import net.devh.boot.grpc.client.config.GrpcChannelProperties;
import net.devh.boot.grpc.client.config.GrpcChannelsProperties;
import net.devh.boot.grpc.client.config.NegotiationType;

@ToString
@Builder
@Getter
public class GrpcChannelConfigurator {

	private String clientName;
	private String address;
	private NegotiationType negotiationType;

	public void addToProperties(GrpcChannelsProperties properties) {
		var clientMap = properties.getClient();

		var channelProps = new GrpcChannelProperties();
		channelProps.setAddress(address);
		channelProps.setNegotiationType(negotiationType);

		clientMap.put(clientName, channelProps);
	}
}
